function [A] = H_Cell(l_entrance,l_center,t,r_bend_inner)

if nargin == 0 %Default
    l_entrance = 4e-5;
    l_center = 1e-4;
    t = 0.1e-4;
    r_bend_inner = 0.1e-4;
elseif nargin ~=4
    error('Not enough input arguments to H_Cell.m');
end

x0 = 0;
x1 = t;
x2 = x1 + r_bend_inner;
x3 = x2 + l_center;
x4 = x3 + r_bend_inner;
x5 = x4 + t;

y0 = 0;
y1 = t;
y2 = y1 + r_bend_inner;
y3 = y2 + l_entrance;




A = [2 x0 x1 -y3 -y3 1 0 0 0 0 0; ...
    2 x1 x1 -y3 -y2 1 0 0 0 0 0; ...
    1 x2 x1 -y1 -y2 0 1 x2 -y2 r_bend_inner r_bend_inner; ...
    2 x2 x3 -y1 -y1 1 0 0 0 0 0; ...
    1 x4 x3 -y2 -y1 0 1 x3 -y2 r_bend_inner r_bend_inner; ...
    2 x4 x4 -y2 -y3 1 0 0 0 0 0; ...
    2 x4 x5 -y3 -y3 1 0 0 0 0 0; ...
    2 x5 x5 -y3 -y2 1 0 0 0 0 0; ...
    1 x5 x3 -y2 -y0 1 0 x3 -y2 r_bend_inner+t r_bend_inner+t; ...
    1 x3 x5 y0 y2 1 0 x3 y2 r_bend_inner+t r_bend_inner+t; ...
    2 x5 x5 y2 y3 1 0 0 0 0 0; ...
    2 x5 x4 y3 y3 1 0 0 0 0 0; ...
    2 x4 x4 y3 y2 1 0 0 0 0 0; ...
    1 x3 x4 y1 y2 0 1 x3 y2 r_bend_inner r_bend_inner; ...
    2 x3 x2 y1 y1 1 0 0 0 0 0; ...
    1 x1 x2 y2 y1 0 1 x2 y2 r_bend_inner r_bend_inner; ...
    2 x1 x1 y2 y3 1 0 0 0 0 0; ...
    2 x1 x0 y3 y3 1 0 0 0 0 0; ...
    2 x0 x0 y3 y2 1 0 0 0 0 0; ...
    1 x0 x2 y2 y0 1 0 x2 y2 r_bend_inner+t r_bend_inner+t; ...
    1 x2 x0 y0 -y2 1 0 x2 -y2 r_bend_inner+t r_bend_inner+t; ...
    2 x0 x0 -y2 -y3 1 0 0 0 0 0;];

A = A';
